<script setup lang="ts">
import axios from 'axios'
import { ref, computed, onMounted } from 'vue'
import { useAuthStore } from '@/stores/auth'

const userStore = useAuthStore()

const isAdmin = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Manager' || role.name === 'Owner')
  }
  return false
})

const itemsToDisplay = computed(() => {
  const currentUser = userStore.getCurrentUser()
  if (isAdmin.value) {
    // If current user is an admin, show data for all users
    return items2.value
  } else if (currentUser !== null && currentUser !== undefined) {
    // If current user is not an admin, show data only for the current user
    return items2.value.filter((item) => item.employeeId === currentUser.id)
  }
  return []
})

const isOwner = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Owner')
  }
  return false
})

console.log(
  //   userStore.getCurrentUser()?.fullName,
  //   userStore.getCurrentUser()?.id,
  userStore.getCurrentUser()?.roles
)

const page = ref(1)
const itemsPerPage = ref<any>(8)

const items = ref<[]>([])

import type { User } from '@/types/User'

const headers = [
  { title: 'ID', key: 'id', sortable: false },
  {
    title: 'Employee ID',
    key: 'employeeId'
  },
  {
    title: 'Name',
    key: 'name'
  },
  // {
  //   title: 'Position',
  //   // key: 'role'
  //   value: (item: any | User) => item.roles.map((r: any) => r.name).join(',')
  // },
  {
    title: 'Check In',
    key: 'checkIn'
  },
  {
    title: 'Check Out',
    key: 'checkOut'
  },
  {
    title: 'Work Hours',
    key: 'workHours'
  }
]
// const headers = ['ID', 'Employee ID',

//   'Name',
//   'Position',
//   'Check In',
//   'Check Out',
//   'Work Hours',

// ]

const pageCount = computed(() => {
  return Math.ceil(items.value.length / itemsPerPage.value)
})

const userCheckInOutData = ref<any>({})
let idDB: number | null = null // ประกาศตัวแปร idDB ไว้นอกฟังก์ชัน checkIn()
async function checkIn() {
  const user: any = userStore.getCurrentUser()
  if (user) {
    const currentTime = new Date()
    if (
      userCheckInOutData.value[user.id] &&
      userCheckInOutData.value[user.id].checkIn &&
      !userCheckInOutData.value[user.id].checkOut
    ) {
      // เพิ่มเงื่อนไขการตรวจสอบการ check-in และยังไม่มีการ check-out
      alert(
        'User has already checked in but not checked out. Cannot check in again until checked out.'
      )
    } else {
      if (!user.timein) {
        user.timein = currentTime
        console.log('user.timein@IN', user.timein)
        try {
          const response = await axios.post('http://localhost:3000/checktime/checkin', {
            employeeId: user.id,
            name: user.fullName,
            role: user.roles,
            checkIn: currentTime,
            status: 'intime'
          })
          idDB = response.data.id
          console.log('Check-in data saved successfully', idDB)

          userCheckInOutData.value = {
            ...userCheckInOutData.value,
            [user.id]: { checkIn: currentTime }
          }
          fetchData()
        } catch (error) {
          console.error('Error while saving check-in data:', error)
        }
      } else {
        alert('User has already checked in.')
      }
    }
  }
}

async function checkOut() {
  const user: any = userStore.getCurrentUser()
  if (user) {
    await fetchData()
    const currentTime = new Date()
    console.log('idDB', idDB)
    try {
      if (userCheckInOutData.value[user.id] && userCheckInOutData.value[user.id].checkIn) {
        // ตรวจสอบว่ามีข้อมูลการลงเวลาเข้าของผู้ใช้นี้ใน userCheckInOutData และมีข้อมูล checkIn
        const checkInTime = new Date(userCheckInOutData.value[user.id].checkIn)
        const workHours = (currentTime.getTime() - checkInTime.getTime()) / (1000 * 60 * 60) / 2 // แปลงเป็นชั่วโมง

        await axios.put(`http://localhost:3000/checktime/checkout/${idDB}`, {
          checkOut: currentTime,
          status: 'timeout',
          workHours: workHours.toFixed(2)
        })

        // Update local user object
        user.timeout = currentTime
        userCheckInOutData.value = {
          ...userCheckInOutData.value,
          [user.id]: { ...userCheckInOutData.value[user.id], checkOut: currentTime }
        }
        fetchData() // Refresh data after checkout
        console.log('Check-out data saved successfully', user.timeout)
        console.log('Check-in time:', userCheckInOutData.value[user.id].checkIn)
        console.log('Check-out time:', userCheckInOutData.value[user.id].checkOut)
        console.log('Work hours:', workHours.toFixed(2)) // แสดงเวลาการทำงานในรูปแบบทศนิยม 2 ตำแหน่ง
      } else {
        // กรณีที่ไม่มีข้อมูลการลงเวลาเข้าของผู้ใช้หรือไม่มีข้อมูล checkIn
        alert('Please check in before checking out.')
      }
    } catch (error) {
      console.error('Error while saving check-out data:', error)
    }
  }
}

const currentUserId = ref<number | null>(null)

onMounted(() => {
  const currentUser = userStore.getCurrentUser()
  if (currentUser) {
    currentUserId.value = currentUser.id
    const userCheckInTime = localStorage.getItem('userCheckInTime')
    if (userCheckInTime) {
      userCheckInOutData.value = {
        ...userCheckInOutData.value,
        [currentUser.id]: { checkIn: new Date(userCheckInTime) }
      }
    }

    fetchData()
  }
})

const items2 = ref<any[]>([])

async function fetchData() {
  try {
    const response = await axios.get('http://localhost:3000/checktime')
    items2.value = response.data
    // console.log('idDB', idDB)
    // localStorage.removeItem('userCheckInTime')
  } catch (error) {
    console.error('Error fetching data:', error)
  }
}

function formatDate(dateString: string | number | Date) {
  const date = new Date(dateString)
  return date.toLocaleString()
}
</script>

<template>
  <div>
    <div class="text-center">
      <h1 style="text-align: left">
        <v-icon icon="mdi mdi-clock" class="mr-2"></v-icon>Work Attendance
      </h1>
    </div>

    <div>
      <v-btn v-if="!isOwner" large color="success" @click="checkIn" class="ma-5">
        <v-icon>mdi-login</v-icon>
        Check In
      </v-btn>
      <v-btn v-if="!isOwner" large color="error" @click="checkOut" class="ml-6">
        Check Out
        <v-icon>mdi-logout</v-icon>
      </v-btn>
    </div>
    <br />
    <v-row>
      <v-col cols="6">
        <v-text-field
          prepend-inner-icon="mdi-magnify"
          density="compact"
          label="Search"
          single-line
          flat
          hide-details
          variant="solo-filled"
        ></v-text-field>
      </v-col>
      <br />
      <br />
    </v-row>

    <v-data-table
      v-model:page="page"
      :headers="headers"
      :items="itemsToDisplay"
      :items-per-page="itemsPerPage"
    >
      <template v-slot:[`item.checkIn`]="{ item }">
        <span>{{ formatDate(item.checkIn) }}</span>
      </template>
      <template v-slot:[`item.checkOut`]="{ item }">
        <span>{{ item.checkOut !== null ? formatDate(item.checkOut) : '' }}</span>
      </template>
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>
    </v-data-table>
  </div>
</template>

<style scoped>
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}

.v-btn {
  font-family: Verdana, sans-serif;
}

div {
  font-family: 'Kanit';
}

.v-btn {
  width: 200px;
  height: 75px;
  color: white;
  font-family: Verdana, sans-serif;
}

.center {
  text-align: center;
}
</style>
